/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
import jasco.util.AbstractFrame;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.SwingConstants;
import javax.swing.border.LineBorder;
 

public class Setup extends AbstractFrame  {

	private String installDir = System.getProperty("user.dir");
	
	public Setup()  {
		
		super("Jasco Setup",400,400);
		//PacoOptions.loadOptions();
		showFinalTab();
	}
	
	protected void showFinalTab()  {
		
		JPanel p = new JPanel();
		setContentPane(p);
		p.setLayout(new BorderLayout());
		final JTextField installDirField = new JTextField(installDir);
		JButton set = new JButton("SETUP");
		set.addActionListener(new ActionListener()  {
			public void actionPerformed(ActionEvent ev)  {
				
				installDir=installDirField.getText();
				File dir = new File(installDir);
				if (!dir.exists())  {
					showErrorDialog("This directory does not exist!");
					return;
				}
				finishSetup();
				quit();
			}
		});
		JLabel explanation1 = new JLabel("Specify the directory where you installed Jasco ,"); 
		JLabel explanation2 = new JLabel("then press SETUP and Jasco is ready to run!");
		JPanel top = new JPanel();
		top.setLayout(new GridLayout(2,1));
		top.add(explanation1);
		top.add(explanation2);
		initTop(explanation1);
		initTop(explanation2);
		p.add("North",top);
		JLabel l = new JLabel("  Installation Directory: ");
		JPanel dir = new JPanel();
		dir.setLayout(new GridLayout());
		dir.add(l);
		dir.add(installDirField);
		JPanel bottom = new JPanel();
		bottom.setLayout(new GridLayout(2,1));
		bottom.add(dir);
		bottom.add(set);
		p.add("South",bottom);
		LineBorder border = new LineBorder(new Color(102,102,197),10);
		top.setBorder(border);
		bottom.setBorder(border);
		pack();
		setVisible(true);
	}
	
	protected void initTop(JLabel comp)  {
		
		comp.setHorizontalAlignment(SwingConstants.CENTER);
		comp.setPreferredSize(new Dimension(comp.getPreferredSize().width,25));
	
		comp.setOpaque(true);
		comp.setForeground(Color.white);
		comp.setBackground(new Color(102,102,197));
	}
	
	public void quit()  {
	
		System.exit(0);
	}
		
	protected void finishSetup()  {
		
		if(installDir.endsWith("/"))
			installDir=installDir.substring(0,installDir.length()-1);
		if(installDir.endsWith("\\"))
			installDir=installDir.substring(0,installDir.length()-1);	
			
		jasco.options.Options.setInstallPath(installDir);
		jasco.options.Options.generateScripts();
		jasco.options.Options.saveClearClassPath();
		
		setVisible(false);
		showInformationDialog("Setup succeeded succesfully!!");
	}
	
	public static void main(String args[]) throws java.io.IOException {
		Setup setup = new Setup();
		/*
		JFrame frame = new JFrame();
		frame.setTitle("Please input number: ");
		Container c = frame.getContentPane();
		BorderLayout l = new BorderLayout();
		c.setLayout(l);
		l.setHgap(10);
		l.setVgap(2);
		c.add(new JTextField());
		c.add("East",new JButton("OK"));
		c.add("North",new JPanel());
		c.add("South",new JPanel());
			c.add("West",new JPanel());
		frame.pack();
		frame.show();*/
	}
}



		
	