/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
package jasco.runtime.aspect;


//import jasco.aspectparser.*;


public class HookPropertyChangeEvent  {
	
	public final static int IS_STATIC = 1;
	public final static int IS_ENABLED = 2;
	public final static int IS_ADDED = 3;
	public final static int IS_REMOVED = 4;
	
	private Object value;
	private int type;
	
	public HookPropertyChangeEvent(int type)  {
		this(type,null);
	}
	
	
	public HookPropertyChangeEvent(int type, Object value)  {
		this.type=type;
		this.value=value;
	}
	
	public boolean getBooleanValue() throws Exception {
	
		return ((Boolean)value).booleanValue();
	}
	
	public Object getValue()  {
	
		return value;
	}
	
	public int getPropertyType()  {
		return type;
	}
}