/*
 * Created on 25-mrt-2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package jasco.runtime.aspect.factory;

import java.util.Hashtable;

import jasco.runtime.MethodJoinpoint;
import jasco.runtime.aspect.IHook;
import jasco.util.logging.Logger;

/* 
 Copyright (C) 2002-2005 JAsCo Development Team
 http://ssel.vub.ac.be/jasco
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as
 published by the Free Software Foundation; either version 2 of the
 License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 USA 
 */

/**
 * convenience class. Remmebers hook instances for given keys.
 * 
 * @author Wim
 */

public abstract class DefaultAspectFactory implements IAspectFactory {

	private Hashtable table =new Hashtable();
	public DefaultAspectFactory() {
		super();
	}

	/* (non-Javadoc)
	 * @see jasco.runtime.aspect.factory.IAspectFactory#getAspectInstance(jasco.runtime.MethodJoinpoint, jasco.runtime.aspect.factory.IAspectInstanceCreator)
	 */
	public IHook getAspectInstance(MethodJoinpoint jp,
			IAspectInstanceCreator creator) {
		
		Object key = getKey(jp);
		if(key==null)
			return null;
		

		IHook currentHook = (IHook) table.get(key);
		if (currentHook==null)  {
		
			try {
				currentHook = creator.createNewInstance();
				table.put(key,currentHook);
			} catch (HookInstantiationFailed e) {
			Logger.getInstance().showError(e);
			}
		}
		return currentHook;
		
	}
	
	/**
	 * Returns the key for looking up hooks given this joinpoint. Key may be null, default hook is used in that case.
	 * 
	 * @param jp joinpoint
	 * @return a key for looking up hooks
	 */
	public abstract Object getKey(MethodJoinpoint jp);

}
