/*
 * Created on 25-mrt-2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package jasco.runtime.aspect.factory;

import jasco.runtime.MethodJoinpoint;
import jasco.runtime.aspect.IHook;

/* 
 Copyright (C) 2002-2005 JAsCo Development Team
 http://ssel.vub.ac.be/jasco
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as
 published by the Free Software Foundation; either version 2 of the
 License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 USA 
 */

/**
 * 
 * Interface for custom aspect factories. Implementing classes have to have a public default constructor!
 * 
 * @author Wim
 */

public interface IAspectFactory {
	/**
	 * Returns the aspect instance applicable at this joinpoint. Use the creator for instantiating new hooks if necessary. 
	 * 
	 * @param jp current joinpoint
	 * @param creator new hook creator
	 * @return the hook instance for jp
	 */
	public IHook getAspectInstance(MethodJoinpoint jp, IAspectInstanceCreator creator);
}
