/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
package jasco.runtime.connector.traversal;

import jasco.runtime.JascoMethod;

public final class TraversalJascoMethod extends JascoMethod {
	
	private boolean docontinue=false;
	
	public TraversalJascoMethod()  {
	}
	
	public TraversalJascoMethod(String aName)  
	{
		super(aName);	
	}
	
	public TraversalJascoMethod(Object self, String aName, String aClassName)  
	{
		super(aName,aName,aClassName,0,null,0);
		
		setCalledObject(self);
		setArgumentsArray(new Object[0]);
	}
	
	public boolean doContinue()  {
		
		return docontinue;
	}
	
	public void doContinue(boolean b)  {
	
		docontinue=b;
	}
	
	public Object invokeOriginalJAsCoMethod()  {
		
		docontinue=true;
		return null;
	}
	
	
	
	public Object invokeOriginal(Object obj, Object[] args) throws Exception  {
	
		docontinue=true;
		return null;
	}
}