/*
 * Created on 2-mrt-2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package jasco.runtime.refinements;



import java.util.Vector;

import jasco.options.Options;
import jasco.runtime.aspect.IHook;
import jasco.runtime.mixin.NoMixinFound;
import jasco.util.logging.Logger;

/* 
 Copyright (C) 2002-2005 JAsCo Development Team
 http://ssel.vub.ac.be/jasco
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as
 published by the Free Software Foundation; either version 2 of the
 License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 USA 
 */

/**
 * @author Wim
 */

public class DefaultRefinement implements IRefinement {

	private Class refinementTarget = null;
	private Class hookClass = null;
	private int prio = 1;
	private String className;
	private String hookClassName;
	private Vector implementedMethods;
	
	public DefaultRefinement(String className, String hookClassName, Vector implementedMethods) {
		super();
		this.className=className;
		this.hookClassName=hookClassName;
		this.implementedMethods=implementedMethods;
	}
	
	protected  void init() {
		
		try {
			
			refinementTarget = Options.loadClass(className);
			hookClass = Options.loadClass(hookClassName);
		}
		catch(ClassNotFoundException ex) {
			Logger.getInstance().showError("Error initilazing refinements");
			Logger.getInstance().showError(ex);
		}
	}

	public boolean isApplicable(Class targetClass, IHook hook, String method) {
		
		if(refinementTarget==null)
			init();
		
		boolean result = true;
		
		result=result&&implementedMethods.contains(method);
		
		result=result&&refinementTarget.isAssignableFrom(targetClass);
		
		result=result&&hook.getClass().isAssignableFrom(hookClass);
		
		return result;
	}
	
	public int getPriority() {
		
		return prio;
	}
	
	protected Object mixinOf(Object target, Class mixin) throws NoMixinFound {
		
		return jasco.runtime.mixin.MixinManager.getInstance().mixinOf(target,mixin);
	}
	

}
