/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
/*
 * Created on 22-okt-2004
 */
package jasco.testing;

import java.io.File;

import jasco.options.Options;

/**
 * @author Wim
 */
public class RunPacoSuiteTest extends DefaultJAsCoTest {
	
	private static final String pacosuiteDir = JAsCoTestMain.getPacoSuiteDir()+Options.FILE_SEPARATOR;
	
	
	public RunPacoSuiteTest(int weaveMethod) {
		super("test description", "");
		
		String desc = "Running PacoSuite using ";
		String command = pacosuiteDir;
		
		String jascoClassPath = "../jasco.jar"+Options.PATH_SEPARATOR+"../jasco-libs.jar";
		
		//TODO: noJUTTA
		
		switch(weaveMethod) {
			
			case TRANSFORM_BEAN:
				desc+="TransformBean";
				command+="tbench.bat";
				break;
			
			case HOTSWAP1:
				desc+="HotSwap1";
				command+="abenchhotswap1.bat";
				break;
				
			case HOTSWAP2:
				desc+="HotSwap2";
				command+="abench.bat";
				break;
				
			case RUNTIME_WEAVER:
				desc+="Run-time Weaver";
				command+="abenchinline.bat";
				break;
				
			default:
				try {
				getGlobalLog().write("Error illegal weaver type: "+weaveMethod);
				} catch(Exception ex){}
		}
		
		setDescription(desc);
	
		File cmd = new java.io.File(command);
		if(!cmd.exists())
			skipTest();
		
		setCommand(cmd.getAbsolutePath());
		addOption("1");
		addOption("true");
	}
	
	public boolean checkOutput(StringBuffer output) {
		
		String s = output.toString();
		return s.indexOf("JASCO DEBUG: joinpoint encountered java.lang.String pacowire.model.PacoComponent.getName()")!=-1;
	}

}
