/*
 * Created on 23-mrt-2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package jasco.tools.aspectparser;

import jasco.util.logging.Logger;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Iterator;

import javassist.CannotCompileException;
import javassist.ClassPool;
import javassist.CtClass;
import javassist.NotFoundException;

/* 
 Copyright (C) 2002-2005 JAsCo Development Team
 http://ssel.vub.ac.be/jasco
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as
 published by the Free Software Foundation; either version 2 of the
 License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 USA 
 */

/**
 * @author Wim
 */

public class ClassFileEditor {

	private final ClassPool pool = new ClassPool(null); //each time new classPool for new receiving CtClass
	private String saveDir;
	private CtClass mainClass;

	public ClassFileEditor(String searchDir, String classname)  {
		 
		saveDir=searchDir;
		try  {
		
		initPool();
		
		mainClass=loadClass(classname);
		mainClass.stopPruning(true);
		
		mainClass.defrost();
		}catch(NotFoundException ex)  {
			Logger.getInstance().showError(ex);
		}
	}
	
	public CtClass getMainClass() {
		
		return mainClass;
	}
	
	private void initPool() throws NotFoundException {
		
		pool.appendSystemPath();
		Iterator i = jasco.options.Options.getClassPathVector().iterator();
		while (i.hasNext())  {
			String s = (String) i.next();
			
			pool.appendClassPath(s);
		}	
		pool.insertClassPath(saveDir);
	}
	
	public final CtClass loadClass(String className) throws NotFoundException {
		
		return pool.get(className);
	}
	
	public final void writeFile() throws IOException,CannotCompileException {
		
		String classDir=saveDir+File.separator+getMainClass().getName().replace('.',File.separatorChar);
		File filetowrite = new File(classDir+".class");
		//filetowrite.delete();
		
		byte[] code = mainClass.toBytecode();
		FileOutputStream out = new FileOutputStream(filetowrite);
		getMainClass().stopPruning(true);
		out.write(code);
		out.close();
	}

}
