/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
package jasco.tools.gui;

import java.awt.Color;
import java.awt.Dimension;

import javax.swing.Icon;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.SwingConstants;
import javax.swing.tree.DefaultMutableTreeNode;

public abstract class AbstractTreeNode extends DefaultMutableTreeNode {
	
	protected final static Color MAIN_COLOR = new Color(102,102,197);
	protected final static Color TEXT_COLOR = Color.white;
	
	
	private String name;
	private Icon icon;
	
	public AbstractTreeNode(String name)  {
	
		this.name=name;
		setUserObject(this);
	}
	
	public Icon getIcon()  {
	
		return icon;
	}
	
	public void setIcon(Icon i)  {
	
		icon=i;
	}
	
	public String getName()  {
	
		return name;
	}
	
	public String toString()  {
	
		return name;
	}
	
	public abstract void initInfoPanel(JPanel infoPanel);
	
	protected void initTop(JLabel comp)  {
		
		comp.setHorizontalAlignment(SwingConstants.CENTER);
		comp.setPreferredSize(new Dimension(comp.getPreferredSize().width,30));
	
		comp.setOpaque(true);
		comp.setForeground(TEXT_COLOR);
		comp.setBackground(MAIN_COLOR);
	}
	
	protected JLabel createTop(String text)  {
	
		JLabel label = new JLabel(text);
		initTop(label);
		return label;
	}
}
	