/*
 * Created on 7-mrt-2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package jasco.tools.refinements;

import jasco.runtime.refinements.RefinementManager;
import jasco.tools.aspectparser.PPackage;
import jasco.tools.jascoparser.JascoParseException;
import jasco.tools.jascoparser.JascoParser;
import jasco.tools.jascoparser.JascoParserTokenManager;
import jasco.tools.jascoparser.PImport;
import jasco.util.logging.Logger;

/* 
 Copyright (C) 2002-2005 JAsCo Development Team
 http://ssel.vub.ac.be/jasco
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as
 published by the Free Software Foundation; either version 2 of the
 License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 USA 
 */

/**
 * @author Wim
 */

public class RefinementParser extends JascoParser {

	private PRefinement refinement;
	
    public RefinementParser(JascoParserTokenManager tokenManager, String aFileName)
    {	
		super(tokenManager,aFileName);
        refinement = new PRefinement();
    }
	
    public void start()
    {
        try
        {
            parsePackageDeclaration(refinement);
            if(!refinement.hasPackage())
            	refinement.setPackage(new PPackage(RefinementManager.getRefinementPackageName(),0));
            else if(!refinement.getPackage().getPackageName().startsWith(RefinementManager.getRefinementPackageName()))
            	throw new JascoParseException(newError("refinements are always in package: "+RefinementManager.REFINING_PACKAGE));
            
            refinement.setImports(parseImportDeclaration());
            refinement.addImport(new PImport(refinement.getPackage().getPackageName()+".*",refinement.getPackage().getLineNumber()));
            parseRefinementDeclaration();
        }
        catch(JascoParseException exception)
        {
            Logger.getInstance().showError(exception.getError());
            Logger.getInstance().showOutput("1 error");
            
			jasco.options.Options.exit(1);
        }
    }
    
    public PRefinement getResult() {
    	
    	return refinement;
    }
    
    protected void parseRefinementDeclaration() throws  JascoParseException{
    	
    	parseDeclarationPreamble(refinement); //modifiers and annnotations
    	int modifiers = refinement.getModifiers();
    	modifiers=setPublic(modifiers);
    	refinement.setModifiers(modifiers);
  
    	assertToken(getCurrentId(),CLASS,newError("class expected"));
    	getNextToken();
    	
    	checkIDENTIFIER("class name expected");
    	String name = getCurrentImage();
    	refinement.setName(name);
    	getNextToken(); 
    	
    	checkFileName(name);
    	
    	assertToken(getCurrentId(),REFINING,newError("refining keyword expected"));
    	getNextToken();
    	
    	checkIDENTIFIER("refining target name expected");
    	String refTargetHookName = accumulateType(refinement.getImports(),TYPE_ASPECT);
    	if(refTargetHookName==null)
    		throw new JascoParseException(newError("target hook for refinement not found"));
    	refinement.setRefinementTargetHook(refTargetHookName);
    	
    	assertToken(getCurrentId(),FOR,newError("for keyword expected"));
    	getNextToken();
    	
    	checkIDENTIFIER("refining target name expected");
    	String refTargetClassName = accumulateType(refinement.getImports());
    	refinement.setRefinementTargetClass(refTargetClassName);
    	
    	parseSuperDeclarations(refinement,refinement.getImports());
    	
    	checkLBRACE("");
    	getNextToken();
    	while(getCurrentId()!=RBRACE) {
    		parseJavaCode(refinement,refinement.getImports());
    	}
    }
}

    
