/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
package jasco.util;

import java.awt.Color;
import java.io.File;

public class EditorOptions {
    public static boolean  trace = true;
    public static String   componentDir     = "components";
    public static String   compositionDir   = "compositions";
    public static String[] messages         = {"REFERENCE", "CONNECT", "RESUME", "SET", "SEND", "NOTIFY", "SPECIFIC", "GET", "STREAM", "SIGNAL", "WAIT", "DISCONNECT", "SUBSCRIBE", "UNSUBSCRIBE", "CREATE", "DESTROY", "START", "STOP", "SUSPEND"};
    public static Color    componentColor   = new Color(50, 50, 50);
    public static Color    compositionColor = new Color(200, 200, 255);
    public static int      componentWidth   = 100;
    public static int      componentHeight  = 50;

    public static File getComponentsDir() {
        return new File("components");
    }
    public static File getCompositionsDir() {
        return new File("compositions");
    }
    public static File getDiagramsDir() {
        return new File("diagrams");
    }
}


