/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
package jasco.util;

import java.util.Vector;

public class Queue {
	
	private final Vector contents = new Vector();
	
	synchronized public void enqueue(Object o) {
		
		contents.add(o);
	}
	
	synchronized public boolean contains(Object o) {
			
		return contents.contains(o);
	}
	
	synchronized public Object dequeue() {
		
		if(contents.size() == 0)
			return null;
			
		Object o = contents.firstElement();
		contents.remove(0);
		return o;
	}
	
	synchronized public boolean isEmpty() {
		
		return contents.isEmpty();
	}
}