/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
package jasco.util.javacompiler;

// Contains compilerror
// Specifies the sourcefile, the linenumber, the specific occured error

public class CompileError 
{
	public final static int GLOBAL_ERROR = -10;
	private String sourcename = null;
	private int linenumber;
	private String errorstring = null;

	public CompileError(String aSourceName, int aLineNumber, String aErrorString)
	{
		sourcename = aSourceName;
		linenumber = aLineNumber;
		errorstring = aErrorString;
	}
	
	public CompileError(String aErrorString)
	{
		sourcename = "noname";
		linenumber = 0;
		errorstring = aErrorString;
	}
	
	public String getSourceName()
	{
		return sourcename;
	}
	
	public int getLineNumber() 
	{
		return linenumber;
	}
	
	public String getErrorString() 
	{
		return errorstring;
	}
	
	public void setSourceName(String aSourceName)
	{
		sourcename = aSourceName;
	}
	
	public void setLineNumber(int aLineNumber) 
	{
		linenumber = aLineNumber;
	}
	
	public void setErrorString(String aErrorString)
	{
		errorstring = aErrorString;
	}
	
	public String toString() 
	{
		if(getLineNumber()==GLOBAL_ERROR)
			return getErrorString();
		return getSourceName() + ":" + getLineNumber() + ":" + getErrorString();
	}
} 
	

		