/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
package jasco.util.logging;

import jasco.options.Options;


public  class ExceptionLogger extends Logger {

	public ExceptionLogger()  {
	} 
	
	public void showError(String error) throws JAsCoException {
	
		throw new JAsCoException(error);
	}
	
	public void showError(String error,Exception ex) throws JAsCoException {
	
		throw new JAsCoException(error,ex);
	}
	
	public void showOutput(String error) throws JAsCoException {
	
		System.out.println(error);
	}
	
	public void showFullError(Exception ex) throws JAsCoException {
		
		showError("!!!!! JASCO SYSTEM ERROR !!!!!!! "+Options.NEWLINE+ex.getMessage(),ex);
	}
	
	public void showFullError(String ex) throws JAsCoException {
		
		showError("!!!!! JASCO SYSTEM ERROR !!!!!!! "+Options.NEWLINE+ex);
	}
	
	public void showError(Exception ex) throws JAsCoException {
	
		showError(ex.getMessage(),ex);
	}

	/* (non-Javadoc)
	 * @see jasco.logging.Logger#showOutputNoNewLine(java.lang.String)
	 */
	public void showOutputNoNewLine(String output) {
		System.out.print(output);
		
	}
	
	
}